#!
#! ---- JNData Split Bar Template for use with JNDSplit.INC/.CLW Class Definitions.
#! ---- Revisions for CW5.5 patch 5 - JMG August 10, 2001
#! ---- 2-28-2001 - Revised underlying Splitbar Object code to fix some bugs.
#! ---- 8-10-2001 - Event handler changed from EVENT:Drag to EVENT:MouseUp
#! ---- 8-15-2001 - Version change to 1.27
#TEMPLATE(JNDSplitBarTemplate,'Split Bar Control Template from JNData'),FAMILY('ABC')
#EXTENSION(JNDSplitBar,'Support Extension for Split Bar Controls'),PROCEDURE
#SHEET
#TAB('Template Setup')
#BOXED('')
#DISPLAY('This is the Procedure Extension Template that')
#DISPLAY('supports the Split Bar Controls')
#DISPLAY('Version 1.27 - August 15, 2001')
#ENDBOXED
#BOXED('')
#PROMPT('Control Minimum DLU',SPIN(@N3,1,300,1)),%JNDSplitMinimum,AT(,,25,),DEFAULT(5)
#DISPLAY('')
#PROMPT('Reset the Window Resize Manager on bar moves',CHECK),%JNDSBMResizer,DEFAULT(1),AT(8)
#ENABLE(%JNDSBMResizer)
#PROMPT('Resize Manager Reset Method',@S40),%JNDSBMResizeMethod,DEFAULT('Resizer.Reset')
#ENDENABLE
#DISPLAY('')
#ENABLE(SLICE(%CWVersion,1,1)<>'4')
#PROMPT('Add "PROP:BUFFER" to the Window',CHECK),%JNDSplitAddPB,AT(8)
#DISPLAY('("PROP:BUFFER" may help diplay flicker.)')
#ENABLE(%JNDSplitAddPB)
#PROMPT('PROP:BUFFER Level',SPIN(@N01,0,2,1)),%JNDSplitPBLevel,DEFAULT(1)
#ENDENABLE
#ENDENABLE
#ENDBOXED
#ENDTAB
#TAB('Info')
#BOXED('')
#DISPLAY('Please feel free to use this, without charge,')
#DISPLAY('as our way of saying "Thank You" to the')
#DISPLAY('Clarion community for all of the support')
#DISPLAY('provided in the past (including other')
#DISPLAY('free template sets).')
#DISPLAY('')
#DISPLAY('Template and the associated Class')
#DISPLAY('definitions Copyright 1999-2001 JNData, LLC.')
#DISPLAY('and were created by Jim Gambon.')
#ENDBOXED
#ENDTAB
#ENDSHEET
#!
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9900),DESCRIPTION('Split bar Manager Init')
    #IF(SLICE(%CWVersion,1,1)='4')
      JNDSBM.INIT(1)  ! Call INIT but tell it to not use REGISTEREVENT handlers.
    #ELSE
      JNDSBM.INIT()
    #ENDIF
      JNDSBM.EdgeBuffer = %JNDSplitMinimum
    #IF(%JNDSplitAddPB AND (SLICE(%CWVersion,1,1)<>'4'))
      0{PROP:BUFFER} = %JNDSplitPBLevel
    #ENDIF
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(8001),DESCRIPTION('Split bar Manager Kill')
    JNDSBM.Kill()
#ENDAT
#!
#! The following not need in C5 because the RegisterEvent handlers work
#AT(%WindowManagerMethodCodeSection,'TakeEvent','(),BYTE'),PRIORITY(6000),DESCRIPTION('C4 CALLS TO SPLIT MANAGER DRAG METHODS')
#! --- Following if C4 detected. This is because C4 seems to not link REGISTEREVENT. So we
#! --- have to make explicit calls to the event handlers.
  #IF(SLICE(%CWVersion,1,1)='4')
    CASE EVENT()
      OF EVENT:MouseUp
        IF JNDSBM.TakeMouseUpEvent()
        END !IF

      OF EVENT:Dragging
        IF JNDSBM.TakeDraggingEvent()
        END !IF

      OF EVENT:MouseMove
        IF JNDSBM.TakeMouseMoveEvent()
        END !IF

    END !CASE
  #ENDIF
#ENDAT
#!
#AT(%DataSection),PRIORITY(3500),DESCRIPTION('Split bar Manager Declaration')
JNDSBM  CLASS(JNDSplitManagerClass)
#EMBED(%JNDSplitbarObjectInstance,'Split Bar Object Instance'),HIDE,LABEL,NOINDENT
        END !CLASS
#ENDAT
#!
#AT(%LocalProcedures),LAST
#?JNDSBM.DraggingStarted         PROCEDURE(LONG BarHandle)
#?
#EMBED(%JNDSplitMoveStartData,'A Split Bar is being moved - Data'),DATA
                              #?CODE
#EMBED(%JNDSplitMoveStartCode,'A Split Bar is being moved - Code')
                              #?RETURN
#?
#ENDAT
#AT(%JNDSplitbarObjectInstance)
#?DraggingStarted     PROCEDURE(LONG BarHandle),VIRTUAL
#ENDAT
#!
#AT(%LocalProcedures),LAST
#?JNDSBM.DraggingStopped         PROCEDURE(LONG BarHandle)
#?
#EMBED(%JNDSplitMoveStopData,'A Split Bar has been dropped in place - Data'),DATA
                              #?CODE
#EMBED(%JNDSplitMoveStopCode,'A Split Bar has been dropped in place - Code')
#IF(%JNDSBMResizer)
                              #?%JNDSBMResizeMethod
#ENDIF
                              #?RETURN
#?
#ENDAT    
#AT(%JNDSplitbarObjectInstance)
#?DraggingStopped     PROCEDURE(LONG BarHandle),VIRTUAL
#ENDAT
#!
#AT(%LocalProcedures),LAST
#?JNDSBM.RedrawFields            PROCEDURE(LONG BarHandle,BYTE Final=0)
#?
#EMBED(%JNDSplitRedrawData,'Split Bar Controls are Redrawing - Data'),DATA
                              #?CODE
#EMBED(%JNDSplitRedrawCode,'Split Bar Controls are Redrawing - Code')
                                #?PARENT.RedrawFields(BarHandle,Final)
#EMBED(%JNDSplitAfterRedrawCode,'Split Bar Controls have Redrawn - Code')
                              #?RETURN
#?
#ENDAT
#AT(%JNDSplitbarObjectInstance)
#?RedrawFields        PROCEDURE(LONG BarHandle,BYTE Final=0),VIRTUAL
#ENDAT
#!
#AT(%AfterGlobalIncludes)
   #ADD(%CustomGlobalDeclarationIncludes,'JNDSPLIT.INC')
#ENDAT
#!---------------------------------------------------------------------------------
#CONTROL(VertSplitBar,'Vertical Bar Control'),WINDOW,MULTI,REQ(JNDSplitBar)
 CONTROLS
   REGION,AT(,,3,),CURSOR(CURSOR:SizeWE),USE(?VSplit),IMM,DRAGID('VSplit'),BEVEL(1,1)
 END
#!
#DECLARE(%JNDSplitLAInstance),MULTI,UNIQUE
#DECLARE(%JNDSplitLAField,%JNDSplitLAInstance),MULTI
#DECLARE(%JNDSplitLAFieldOpt,%JNDSplitLAInstance),MULTI
#DECLARE(%JNDSplitRBInstance),MULTI,UNIQUE
#DECLARE(%JNDSplitRBField,%JNDSplitRBInstance),MULTI
#DECLARE(%JNDSplitRBFieldOpt,%JNDSplitRBInstance),MULTI
#!
#PREPARE
  #FIX(%Control,%ActiveTemplateInstance)
#ENDPREPARE
#!
#DISPLAY('')
#DISPLAY('Vertical Split bar - ' & %Control)
#DISPLAY('Using Handle Variable - SplitHandle:' & %ControlInstance)
#DISPLAY('')
#SHEET
#TAB('Screen Controls Left')
#BOXED('')
#BUTTON('A Control Left'),AT(,,,70),MULTI(%JNDSplitLAInstance,%JNDSplitLAField & ' - ' & %JNDSplitLAFieldOpt),INLINE
#PROMPT('Screen Control',CONTROL),%JNDSplitLAField,REQ,UNIQUE
#PROMPT('Action',OPTION),%JNDSplitLAFieldOpt
#PROMPT('Resize',RADIO)
#PROMPT('Move',RADIO)
#ENDBUTTON
#ENDBOXED
#ENDTAB
#TAB('Screen Controls Right')
#BOXED('')
#BUTTON('A Control Right'),AT(,,,70),MULTI(%JNDSplitRBInstance,%JNDSplitRBField & ' - ' & %JNDSplitRBFieldOpt),INLINE
#PROMPT('Screen Control',CONTROL),%JNDSplitRBField,REQ,UNIQUE
#PROMPT('Action',OPTION),%JNDSplitRBFieldOpt
#PROMPT('Resize',RADIO)
#PROMPT('Move',RADIO)
#ENDBUTTON
#ENDBOXED
#ENDTAB                                                                    
#ENDSHEET
#PROMPT('Redraw Controls as Bar is Being Moved',CHECK),%JNDSplitRedraw,AT(8)
#!
#ATSTART
  #DECLARE(%JNDSplitControlUse)
  #DECLARE(%JNDSplitControl)
  #DECLARE(%JNDSplitTypeName)
  #DECLARE(%JNDSplitHandle)
  #DECLARE(%JNDSplitFEQ)
  #DECLARE(%JNDSplitLeftAbove)
  #DECLARE(%JNDSplitRightBelow)
  #!   DECLARE(%JNDSplitRedraw,LONG)
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
    #SET(%JNDSplitControlUse,%ControlUse)
    #SET(%JNDSplitControl,%ControlInstance)
    #SET(%JNDSplitTypeName,'AddVertSplit')
    #SET(%JNDSplitHandle,'SplitHandle:' & %JNDSplitControl)
    #SET(%JNDSplitLeftAbove,'Left')
    #SET(%JNDSplitRightBelow,'Right')
    #SET(%JNDSplitFEQ,%Control)
    #SET(%JNDSplitControlUse,%ControlUse)
  #ENDFOR
#ENDAT
#!
#AT(%DataSection),PRIORITY(3500),DESCRIPTION('Split bar Handle for ' & %JNDSplitFEQ)
%JNDSplitHandle LONG
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9901),DESCRIPTION('Split bar Manager Add Item')
#CALL(%JNDSplitCode)
#ENDAT
#!---------------------------------------------------------------------------
#CONTROL(HorzSplitBar,'Horizontal Bar Control'),WINDOW,MULTI,REQ(JNDSplitBar)
 CONTROLS
   REGION,AT(,,,3),CURSOR(CURSOR:SizeNS),USE(?HSplit),IMM,DRAGID('HSplit'),BEVEL(1,1)
 END
#!
#DECLARE(%JNDSplitLAInstance),MULTI,UNIQUE
#DECLARE(%JNDSplitLAField,%JNDSplitLAInstance),MULTI
#DECLARE(%JNDSplitLAFieldOpt,%JNDSplitLAInstance),MULTI
#DECLARE(%JNDSplitRBInstance),MULTI,UNIQUE
#DECLARE(%JNDSplitRBField,%JNDSplitRBInstance),MULTI
#DECLARE(%JNDSplitRBFieldOpt,%JNDSplitRBInstance),MULTI
#!
#PREPARE
  #FIX(%Control,%ActiveTemplateInstance)
#ENDPREPARE
#!
#DISPLAY('')
#DISPLAY('Horizontal Split bar - ' & %Control)
#DISPLAY('Using Handle Variable - SplitHandle:' & %ControlInstance)
#DISPLAY('')
#SHEET
#TAB('Screen Controls Above')
#BOXED('')
#BUTTON('A Control Above'),AT(,,,70),MULTI(%JNDSplitLAInstance,%JNDSplitLAField & ' - ' & %JNDSplitLAFieldOpt),INLINE
#PROMPT('Screen Control',CONTROL),%JNDSplitLAField,REQ,UNIQUE
#PROMPT('Action',OPTION),%JNDSplitLAFieldOpt
#PROMPT('Resize',RADIO)
#PROMPT('Move',RADIO)
#ENDBUTTON
#ENDBOXED
#ENDTAB
#TAB('Screen Controls Below')
#BOXED('')
#BUTTON('A Control Below'),AT(,,,70),MULTI(%JNDSplitRBInstance,%JNDSplitRBField & ' - ' & %JNDSplitRBFieldOpt),INLINE
#PROMPT('Screen Control',CONTROL),%JNDSplitRBField,REQ,UNIQUE
#PROMPT('Action',OPTION),%JNDSplitRBFieldOpt
#PROMPT('Resize',RADIO)
#PROMPT('Move',RADIO)
#ENDBUTTON
#ENDBOXED
#ENDTAB                                                                    
#ENDSHEET
#PROMPT('Redraw Controls as Bar is Being Moved',CHECK),%JNDSplitRedraw,AT(8)
#!
#ATSTART
  #DECLARE(%JNDSplitControlUse)
  #DECLARE(%JNDSplitControl)
  #DECLARE(%JNDSplitTypeName)
  #DECLARE(%JNDSplitHandle)
  #DECLARE(%JNDSplitFEQ)
  #DECLARE(%JNDSplitLeftAbove)
  #DECLARE(%JNDSplitRightBelow)
  #!    DECLARE(%JNDSplitRedraw,LONG)
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
    #SET(%JNDSplitControlUse,%ControlUse)
    #SET(%JNDSplitControl,%ControlInstance)
    #SET(%JNDSplitTypeName,'AddHorzSplit')
    #SET(%JNDSplitHandle,'SplitHandle:' & %JNDSplitControl)
    #SET(%JNDSplitLeftAbove,'Above')
    #SET(%JNDSplitRightBelow,'Below')
    #SET(%JNDSplitFEQ,%Control)
    #SET(%JNDSplitControlUse,%ControlUse)
  #ENDFOR
#ENDAT
#!
#AT(%DataSection),PRIORITY(3500),DESCRIPTION('Split bar Handle for ' & %JNDSplitFEQ)
%JNDSplitHandle LONG
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9901),DESCRIPTION('Split bar Manager Add Item')
#CALL(%JNDSplitCode)
#ENDAT
#!--------Groups------------------
#!
#GROUP(%JNDSplitCode)
    %JNDSplitHandle = JNDSBM.%JNDSplitTypeName(%JNDSplitFEQ)
    #IF(%JNDSplitRedraw)
      JNDSBM.SetBarRedrawFlag(%JNDSplitHandle,TRUE)
    #ENDIF
    #FOR(%JNDSplitLAInstance)
      #IF(%JNDSplitLAFieldOpt <> 'Move')
        JNDSBM.AddField%JNDSplitLeftAbove(%JNDSplitHandle,%JNDSplitLAField)
      #ELSE
        JNDSBM.AddField%JNDSplitLeftAbove(%JNDSplitHandle,%JNDSplitLAField,1)
      #ENDIF
    #ENDFOR
    #FOR(%JNDSplitRBInstance)
      #IF(%JNDSplitRBFieldOpt <> 'Move')
        JNDSBM.AddField%JNDSplitRightBelow(%JNDSplitHandle,%JNDSplitRBField)
      #ELSE
        JNDSBM.AddField%JNDSplitRightBelow(%JNDSplitHandle,%JNDSplitRBField,1)
      #ENDIF
    #ENDFOR
